using System;
using System.Collections.Generic;
using FairyGUI;
using FGUI.Common_01;
using FGUI.P14_PassView;
using SGModule.Net;
using SGModule.NetKit;

namespace ChillConnect
{
    public class PassunlockUI : BaseUI
    {
        private PassunlockUICtrl ctrl;
        private PassunlockModel model;
        private com_passunlock ui;

        public btn_watchAd btn_WatchAd;

        public PassunlockUI(PassunlockUICtrl ctrl) : base(ctrl)
        {
            uiName = UIConst.PassunlockUI;
            this.ctrl = ctrl;
        }

        protected override void SetUIInfo(UIInfo uiInfo)
        {
            uiInfo.packageName = "P14_PassView";
            uiInfo.assetName = "com_passunlock";
            uiInfo.layerType = UILayerType.Popup;
            uiInfo.isNeedOpenAnim = false;
            uiInfo.isNeedCloseAnim = false;
            uiInfo.isNeedUIMask = true;
        }

        #region 生命周期
        protected override void OnInit()
        {
            //model = ModuleManager.Instance.GetModel(ModelConst.PassunlockModel) as PassunlockModel;
        }

        protected override void OnClose()
        {
            AdRedeemManager.Instance.Destroy();
            GameHelper.CallShowTurn();
        }

        protected override void OnBind()
        {
            ui = baseUI as com_passunlock;
        }

        protected override void OnOpenBefore(object args)
        {
            if (GameHelper.IsGiftSwitch() && ConfigSystem.GetConfig<CommonModel>().PiggyBankSwitch == 1)
            {
                (ui.btn_max_pay.GetChild("img_saveingpot") as GImage).visible = true;
                ui.btn_buypass.GetChild("img_saveingpot").visible = true;
            }

            if (GameHelper.IsAdModelOfPay())
            {
                ui.pay_type.selectedIndex = 0;
                btn_watchAd btn = ui.btn_buypass as btn_watchAd;
                btn.buy_type.selectedIndex = 0;
                AdRedeemManager.Instance.SetWatchAd(PurchasingManager.GetPaySku(PayType.battle_pass), ui.btn_buypass as btn_watchAd, SetTextString);

                AdRedeemManager.Instance.Start();
                SetTextString();

            }
            else
            {
                ui.pay_type.selectedIndex = 1;
                decimal price = (decimal)GameHelper.GetCommonModel().Passportgift2;
                ui.btn_max_pay.title = GameHelper.getPrice(price);
                ui.btn_max_pay.SetClick(() =>
                {
                    ApplePayClass maxPayData = new ApplePayClass
                    {
                        amount = (int)Math.Round(price * 100),
                        sku = PurchasingManager.GetPaySku(PayType.battle_pass),
                        currency = "USD"
                    };
                    MaxPayManager.Instance.Buy(maxPayData);
                });
            }

            InitView();
            TrackKit.SendEvent(GameHelper.getTrackEvenName(),Property.PassShow);

        }

        protected override void OnOpen(object args)
        {
        }

        protected override void OnHide()
        {
        }

        protected override void OnDisplay(object args)
        {
        }
        #endregion

        #region 消息
        protected override void AddListener()
        {
            GameDispatcher.Instance.AddListener(GameMsg.apple_pay_success, pay_success);
        }
        protected override void RemoveListener()
        {
            GameDispatcher.Instance.RemoveListener(GameMsg.apple_pay_success, pay_success);
        }
        #endregion
        void pay_success(object str)
        {
            string type = (string)str;
            if (type == PurchasingManager.GetPaySku(PayType.battle_pass))
            {
                CtrlCloseUI();
            }
        }
        //初始化页面逻辑
        private void InitView()
        {
            ui.btn_close.SetClick(CtrlCloseUI);
            int gold = 0;

            List<Passportrewards> Passportrewards_list = ConfigSystem.GetConfig<PassportrewardsModel>().DataList;
            for (int i = 0; i < Passportrewards_list.Count; i++)
            {

                if (Passportrewards_list[i].Paid_rewards_type == 0) gold += Passportrewards_list[i].Paid_rewards_num;

            }
            ui.text_allgold.text = GameHelper.Get101Str(gold);
           

        }

        public void SetTextString()
        {
            var need = AdRedeemManager.Instance.GetCeilingNeedAds(PurchasingManager.GetPaySku(PayType.battle_pass));
            var myAd = AdRedeemManager.Instance.GetLookRewardADNum();

            ui.tips.SetVar("num", need.ToString()).FlushVars();
            ui.ads.SetVar("num", myAd.ToString()).FlushVars();
        }
    }
}